# coffeelint: disable=max_line_length

_ = require "lodash"
fs = require 'fs-extra'
async = require 'async'
chalk = require 'chalk'

Producer = require '../../ProducerClass'
child_process = require 'child_process'

running = true
watcher = false

debug = require("../../../shared_modules/logger").debug

class Callinfo extends Producer
  constructor: ->
    super "callinfo", 15 * 1000

    intervalTimeToGetNewData = 5 * 1000
    getNewData = false

    getCalls = =>
      child_process.exec "omggetcalls", (error, stdout) =>
        if error
          debug "error running getstates:", error
          return

        if stdout
          results = JSON.parse(stdout)
          debug "new calls states"#, results
          @sendData results
    getCalls()

    @start = =>
      if @running
        debug "already running"
        return
      debug "starting"
      @running = true
      getCalls()
      clearInterval getNewData if getNewData
      getNewData = setInterval getCalls, intervalTimeToGetNewData #5 * 1000

    @stop = =>
      unless @running
        debug "Not running"
        return
      debug "stopping"
      clearInterval getNewData if getNewData
      @running = false


  subscribe: =>
    unless @running
      @start()
    super()

module.exports = new Callinfo()
